;timer.bb
;BlitzBoy
;
;Created by Jan Ebbe on 05.01.2012


Global timer_div
Global timer_tima
Global timer_tma
Global timer_tac
Global timer_div_counter
Global timer_counter


Function timer_reset()
	timer_div = 0
	timer_tima = 0
	timer_tma = 0
	timer_tac = 0
	timer_div_counter = 0
	timer_counter = 0
End Function

Function timer_step()
	;Divider Increment
	timer_div_counter = timer_div_counter + cpu_m
	If timer_div_counter >= 64 Then
		timer_div = (timer_div + 1) And $FF
		timer_div_counter = timer_div_counter - 64
	End If
	
	;Timer
	If (timer_tac And $04) > 0 Then
		timer_counter = timer_counter + cpu_m
		clock_select = timer_tac And $03
		
		If clock_select = 0 And timer_counter >= 256 Then
			timer_tima = timer_tima + 1
			timer_counter = timer_counter - 256
		Else If clock_select = 1 And timer_counter >= 4 Then
			timer_tima = timer_tima + 1
			timer_counter = timer_counter - 4
		Else If clock_select = 2 And timer_counter >= 16 Then
			timer_tima = timer_tima + 1
			timer_counter = timer_counter - 16
		Else If clock_select = 3 And timer_counter >= 64 Then
			timer_tima = timer_tima + 1
			timer_counter = timer_counter - 64
		End If
		
		If timer_tima >= $100 Then
			timer_tima = timer_tma
			memory_if = memory_if Or $04
		End If
	End If
End Function