;keypad.bb
;BlitzBoy
;
;Created by Jan Ebbe on 05.01.2012


Dim keypad_rows (1)
Global keypad_column

Global keypad_up
Global keypad_right
Global keypad_down
Global keypad_left
Global keypad_a
Global keypad_b
Global keypad_select
Global keypad_start


Function keypad_reset()
	keypad_column = 0
	
	Dim keypad_rows (1)
End Function

Function keypad_down(code)
	If code = keypad_right Then ;Right
		cpu_stop = 0
		memory_if = memory_if Or $10
		keypad_rows (1) = keypad_rows (1) And $0E 
	Else If code = keypad_left Then ;Left
		cpu_stop = 0
		memory_if = memory_if Or $10
		keypad_rows (1) = keypad_rows (1) And $0D
	Else If code = keypad_up Then ;Up
		cpu_stop = 0
		memory_if = memory_if Or $10
		keypad_rows (1) = keypad_rows (1) And $0B
	Else If code = keypad_down Then ;Down
		cpu_stop = 0
		memory_if = memory_if Or $10
		keypad_rows (1) = keypad_rows (1) And $07
	Else If code = keypad_a Then ;A
		cpu_stop = 0
		memory_if = memory_if Or $10
		keypad_rows (0) = keypad_rows (0) And $0E
	Else If code = keypad_b Then ;B
		cpu_stop = 0
		memory_if = memory_if Or $10
		keypad_rows (0) = keypad_rows (0) And $0D
	Else If code = keypad_select Then ;Select
		cpu_stop = 0
		memory_if = memory_if Or $10
		keypad_rows (0) = keypad_rows (0) And $0B
	Else If code = keypad_start Then ;Start
		cpu_stop = 0
		memory_if = memory_if Or $10
		keypad_rows (0) = keypad_rows (0) And $07
	End If
	
	gui_render_background() 
End Function

Function keypad_up(code)
	If code = keypad_right Then ;Right
		keypad_rows (1) = keypad_rows (1) Or $01
	Else If code = keypad_left Then ;Left
		keypad_rows (1) = keypad_rows (1) Or $02
	Else If code = keypad_up Then ;Up
		keypad_rows (1) = keypad_rows (1) Or $04
	Else If code = keypad_down Then ;Down
		keypad_rows (1) = keypad_rows (1) Or $08
	Else If code = keypad_a Then ;A
		keypad_rows (0) = keypad_rows (0) Or $01
	Else If code = keypad_b Then ;B
		keypad_rows (0) = keypad_rows (0) Or $02
	Else If code = keypad_select Then ;Select
		keypad_rows (0) = keypad_rows (0) Or $04
	Else If code = keypad_start Then ;Start
		keypad_rows (0) = keypad_rows (0) Or $08
	End If
	
	gui_render_background() 
End Function

Function keypad_all_up()
	keypad_rows (0) = $0F
	keypad_rows (1) = $0F
	
	gui_render_background() 
End Function